{% extends 'base.html' %}
{% load static %}

{% block content %}
<div>
    <!-- backward-button -->
    <a class="underlined-link" href="{% url appname|add:'_list' %}">&lsaquo; Back</a>

    <!-- element title -->
    <h1 class="no-margin">{{ object.title }}</h1>

    <hr>

    <!-- element information -->
    <div class="container-flex">
        <!-- shown information specified for each app -->
        {% if appname == 'articlesummaries' %}
        <div class="row">
            <div class="table-first-column">Authors:</div>
            <div class="col-md table-second-column">
                {% for author, profile_url in author_profile_urls.items %}
                    {% if profile_url %}
                        <a href="{{ profile_url }}" target="_blank">{{ author }}</a>
                    {% else %}
                        {{ author }}
                    {% endif %}
                    {% if not forloop.last %}, {% endif %}
                {% endfor %}
            </div>
        <div class="row">
            <div class="table-first-column">Year of Publication:</div>
            <div class="col-md table-second-column">{{ object.pub_year }}</div>
        </div>
        <div class="row">
            <div class="table-first-column">DOI:</div>
            {% if object.doi %}
            <div class="col-md table-second-column"><a class="doi-link" href="https://doi.org/{{ object.doi }}" target="_blank">{{ object.doi }}</a></div>
            {% else %} 
            <div class="col-md table-second-column">&#8722;</div>
            {% endif %}
        </div>
        <div class="row">
            <div class="table-first-column">Journal / Conference:</div>
            <div class="col-md table-second-column">{{ object.jour_conf|default:"&#8722;" }}</div>
        </div>

        {% elif appname == 'projectsummaries' %}
        <div class="row">
            <div class="table-first-column">Participating Insitutions:</div>
            <div class="col-md table-second-column">{{ object.institutions|default:"&#8722;" }}</div>
        </div>
        <div class="row">
            <div class="table-first-column">Summary Author:</div>
            <div class="col-md table-second-column">{{ object.authors }}</div>
        </div>
        <div class="row">
            <div class="table-first-column">Project Website:</div>
            {% if object.url %}
            <div class="col-md table-second-column"><a class="doi-link" href="{{ object.url }}" target="_blank">{{ object.url }}</a></div>
            {% else %} 
            <div class="col-md table-second-column">&#8722;</div>
            {% endif %}
        </div>

        {% elif appname == 'educationalcontent' %}
        <div class="row">
            <div class="table-first-column">Institution:</div>
            <div class="col-md table-second-column">{{ object.institutions|default:"&#8722;" }}</div>
        </div>
        <div class="row">
            <div class="table-first-column">Department:</div>
            <div class="col-md table-second-column">{{ object.department|default:"&#8722;" }}</div>
        </div>
        <div class="row">
            <div class="table-first-column">Lecturer(s):</div>
            <div class="col-md table-second-column">{{ object.authors }}</div>
        </div>
        <div class="row">
            <div class="table-first-column">Year of original Publication:</div>
            <div class="col-md table-second-column">{{ object.pub_year }}</div>
        </div>
        <div class="row">
            <div class="table-first-column">Difficulty:</div>
            <div class="col-md table-second-column">{{ object.difficulty }}</div>
        </div>
        {% endif %}

        <!-- display areas -->
        <div class="row">
            <div class="table-first-column">Areas:</div>
            <div class="col-md table-second-column no-margin-bottom">
                <p class="table-area-listing"><a href="{% url appname|add:'_list' %}?area={{object.area1}}">{{ object.get_area1_display }}</a></p>
                {% if object.area2 %}
                <br>
                <p class="table-area-listing"><a href="{% url appname|add:'_list' %}?area={{object.area2}}">{{ object.get_area2_display }}</a></p>
                {% endif %}
                {% if object.area3 %}
                <br>
                <p class="table-area-listing"><a href="{% url appname|add:'_list' %}?area={{object.area3}}">{{ object.get_area3_display }}</a></p>
                {% endif %}
            </div>
        </div>
    </div>
    
    <hr>

    <!-- Display PDF Files if Existing -->    
    {% if appname == 'articlesummaries' or appname == 'projectsummaries' %}
        {% if pdfs %}
        <div class="pdf-container">
            <ul>
                {% for pdf in pdfs %}
                    {% if pdf.pdf %}
                    <div class="pdf-box">
                        <a href="{{ pdf.pdf.url }}" target="_blank">
                            <img src="{% static 'images/pdf.png' %}" alt="PDF Icon" class="pdf-icon">
                        </a>
                        <div class="pdf-title">
                            <a href="{{ pdf.pdf.url }}" target="_blank">
                                {{ pdf.description|default:pdf.get_filename }}
                            </a>
                        </div>
                    </div>
                    {% endif %}
                {% empty %}
                    <div>No PDF files available.</div>
                {% endfor %}
            </ul>
        </div>
        {% else %}
        <div>No PDF files associated with this article.</div>
        {% endif %}
    {% endif %}

    <hr>

    <!-- text depending on the app -->
    {% if appname == 'articlesummaries' %}
    <div>
        <p class="header-paragraph">Abstract</p>
        <p class="keep-paragraphs">{{ object.abstract }}</p>

        <div class="spacer-div"></div>

        <p class="header-paragraph">Summary</p>
        <p class="keep-paragraphs">{{ object.summary }}</p>
    </div>

    {% elif appname == 'projectsummaries' %}
    <div>
        <p class="header-paragraph">Short Introduction</p>
        <p class="keep-paragraphs">{{ object.introduction }}</p>

        <div class="spacer-div"></div>

        <p class="header-paragraph">Summary</p>
        <p class="keep-paragraphs">{{ object.summary }}</p>
    </div>

    {% elif appname == 'educationalcontent' %}
    <div>
        {% block detail_educationalcontent %}
        {% endblock %}
    </div>

    {% elif appname == 'forum' %}
    <div>
        {% block detail_forum %}
        {% endblock %}
    </div>
    {% endif %}

    <div class="spacer-div"></div>
    {% if object.images.exists %}
    <div>
        <p class="header-paragraph">Attached Images:</p>
        <ul>
            {% for image in object.images.all %}
            {% if image.image %}
            <li><img src="{{ image.image.url }}" alt="{{ image.caption }}">
                {% if image.caption %}
                <figcaption>Figure: {{ image.caption }}</figcaption>
                {% endif %}
            </li>
            {% else %}
            <li><p>No image file associated.</p></li>
            {% endif %}
            {% empty %}
            <li><p>No images available.</p></li>
            {% endfor %}
        </ul>
    </div>
    <div class="spacer-div"></div>
    {% endif %}

    <div class="spacer-div"></div>

    <!-- edit & delete button -->
    {% if appname != 'forum' %}
    <div>
        <a class="link-button" href="{% url appname|add:'_update' object.slug %}">Edit</a>
        <a class="link-button" href="{% url appname|add:'_delete' object.slug %}">Delete</a>
    </div>
    {% endif %}
</div>
{% endblock %}